<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LeaseCharge StructType
 * @subpackage Structs
 */
class LeaseCharge extends LeaseLedgerItem
{
    /**
     * The appliedItems
     * Meta information extracted from the WSDL
     * - arrayType: tns1:LeaseAppliedToChargeItem[]
     * - base: soapenc:Array
     * - nillable: true
     * - ref: soapenc:arrayType
     * @var \StructType\LeaseAppliedToChargeItem[]
     */
    public $appliedItems;
    /**
     * The comments
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $comments;
    /**
     * The date
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $date;
    /**
     * The referenceNumber
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $referenceNumber;
    /**
     * Constructor method for LeaseCharge
     * @uses LeaseCharge::setAppliedItems()
     * @uses LeaseCharge::setComments()
     * @uses LeaseCharge::setDate()
     * @uses LeaseCharge::setReferenceNumber()
     * @param \StructType\LeaseAppliedToChargeItem[] $appliedItems
     * @param string $comments
     * @param string $date
     * @param string $referenceNumber
     */
    public function __construct(array $appliedItems = array(), $comments = null, $date = null, $referenceNumber = null)
    {
        $this
            ->setAppliedItems($appliedItems)
            ->setComments($comments)
            ->setDate($date)
            ->setReferenceNumber($referenceNumber);
    }
    /**
     * Get appliedItems value
     * @return \StructType\LeaseAppliedToChargeItem[]|null
     */
    public function getAppliedItems()
    {
        return $this->appliedItems;
    }
    /**
     * This method is responsible for validating the values passed to the setAppliedItems method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAppliedItems method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAppliedItemsForArrayConstraintsFromSetAppliedItems(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $leaseChargeAppliedItemsItem) {
            // validation for constraint: itemType
            if (!$leaseChargeAppliedItemsItem instanceof \StructType\LeaseAppliedToChargeItem) {
                $invalidValues[] = is_object($leaseChargeAppliedItemsItem) ? get_class($leaseChargeAppliedItemsItem) : sprintf('%s(%s)', gettype($leaseChargeAppliedItemsItem), var_export($leaseChargeAppliedItemsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The appliedItems property can only contain items of type \StructType\LeaseAppliedToChargeItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set appliedItems value
     * @throws \InvalidArgumentException
     * @param \StructType\LeaseAppliedToChargeItem[] $appliedItems
     * @return \StructType\LeaseCharge
     */
    public function setAppliedItems(array $appliedItems = array())
    {
        // validation for constraint: array
        if ('' !== ($appliedItemsArrayErrorMessage = self::validateAppliedItemsForArrayConstraintsFromSetAppliedItems($appliedItems))) {
            throw new \InvalidArgumentException($appliedItemsArrayErrorMessage, __LINE__);
        }
        $this->appliedItems = $appliedItems;
        return $this;
    }
    /**
     * Add item to appliedItems value
     * @throws \InvalidArgumentException
     * @param \StructType\LeaseAppliedToChargeItem $item
     * @return \StructType\LeaseCharge
     */
    public function addToAppliedItems(\StructType\LeaseAppliedToChargeItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LeaseAppliedToChargeItem) {
            throw new \InvalidArgumentException(sprintf('The appliedItems property can only contain items of type \StructType\LeaseAppliedToChargeItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->appliedItems[] = $item;
        return $this;
    }
    /**
     * Get comments value
     * @return string|null
     */
    public function getComments()
    {
        return $this->comments;
    }
    /**
     * Set comments value
     * @param string $comments
     * @return \StructType\LeaseCharge
     */
    public function setComments($comments = null)
    {
        // validation for constraint: string
        if (!is_null($comments) && !is_string($comments)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comments, true), gettype($comments)), __LINE__);
        }
        $this->comments = $comments;
        return $this;
    }
    /**
     * Get date value
     * @return string|null
     */
    public function getDate()
    {
        return $this->date;
    }
    /**
     * Set date value
     * @param string $date
     * @return \StructType\LeaseCharge
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date, true), gettype($date)), __LINE__);
        }
        $this->date = $date;
        return $this;
    }
    /**
     * Get referenceNumber value
     * @return string|null
     */
    public function getReferenceNumber()
    {
        return $this->referenceNumber;
    }
    /**
     * Set referenceNumber value
     * @param string $referenceNumber
     * @return \StructType\LeaseCharge
     */
    public function setReferenceNumber($referenceNumber = null)
    {
        // validation for constraint: string
        if (!is_null($referenceNumber) && !is_string($referenceNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($referenceNumber, true), gettype($referenceNumber)), __LINE__);
        }
        $this->referenceNumber = $referenceNumber;
        return $this;
    }
}
